'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

var _mapping = require('./_mapping');

var _mapping2 = _interopRequireDefault(_mapping);

var _getPropertyName = require('./get-property-name');

var _getPropertyName2 = _interopRequireDefault(_getPropertyName);

var _setReplaced = require('./set-replaced');

var _setReplaced2 = _interopRequireDefault(_setReplaced);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

exports.default = function (fn, args) {
  var fnName = (0, _getPropertyName2.default)(fn);

  var fnArity = _fp2.default.flow(_fp2.default.map(_fp2.default.flow(_fp2.default.toString, _fp2.default.get(_fp2.default, _mapping2.default.aryMethod), _fp2.default.includes(fnName))), _fp2.default.findIndex(_fp2.default.identity), _fp2.default.add(1))(_fp2.default.range(1, 5));

  var fnRearg = void 0;
  if (fnArity === 0) {
    fnRearg = _fp2.default.range(0, args.length);
  } else if (fnArity === 1) {
    fnRearg = [0];
  } else if (_mapping2.default.skipRearg[fnName]) {
    fnRearg = _fp2.default.flow(_fp2.default.toNumber, _fp2.default.range(0))(fnArity);
  } else {
    fnRearg = _mapping2.default.methodRearg[fnName] || _mapping2.default.aryRearg[fnArity];
  }

  var newArgs = _fp2.default.flow(_fp2.default.map(function (index) {
    return args[_fp2.default.indexOf(index)(fnRearg)];
  }), _fp2.default.dropRightWhile(_fp2.default.flow(_fp2.default.get('name'), _fp2.default.isEqual('_'))))(_fp2.default.range(0, fnRearg.length));

  if (_fp2.default.isEmpty(newArgs)) {
    return fn;
  } else {
    return (0, _setReplaced2.default)(t.callExpression(fn, _fp2.default.compact(newArgs)));
  }
};