'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _getPropertyName = require('./get-property-name');

var _getPropertyName2 = _interopRequireDefault(_getPropertyName);

var _setReplaced = require('./set-replaced');

var _setReplaced2 = _interopRequireDefault(_setReplaced);

var _buildCall = require('./build-call');

var _buildCall2 = _interopRequireDefault(_buildCall);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (path) {
  var parentPath = path.parentPath;
  var flowArgs = path.node.arguments;


  var currentPath = parentPath;
  var loop = (0, _getPropertyName2.default)(currentPath.node) !== 'value';
  var flowFunctions = [];
  while (loop) {
    var _currentPath = currentPath;
    var node = _currentPath.node;

    var args = currentPath.parentPath.node.arguments;

    flowFunctions.push({
      name: (0, _getPropertyName2.default)(node),
      args: args
    });

    var grandparentPath = currentPath.parentPath.parentPath;
    var grandparentNode = grandparentPath.node;
    var greatGrandparentNode = grandparentPath.parentPath.node;
    var expPattern = t.isMemberExpression(grandparentNode) && t.isCallExpression(greatGrandparentNode);
    loop = expPattern && (0, _getPropertyName2.default)(grandparentNode) !== 'value';

    if (expPattern) currentPath = grandparentPath;
  }

  currentPath.parentPath.replaceWith((0, _setReplaced2.default)(t.callExpression((0, _setReplaced2.default)(t.callExpression(t.memberExpression(t.identifier('_'), t.identifier('flow')), _fp2.default.map(function (_ref) {
    var name = _ref.name;
    var args = _ref.args;
    return (0, _buildCall2.default)(t.memberExpression(t.identifier('_'), t.identifier(name)), _fp2.default.concat([t.identifier('_')], args));
  })(flowFunctions))), flowArgs)));
};