'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

var _buildCall = require('./build-call');

var _buildCall2 = _interopRequireDefault(_buildCall);

var _isLodashCall = require('./is-lodash-call');

var _isLodashCall2 = _interopRequireDefault(_isLodashCall);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

exports.default = function (path, returnNode, params) {
  if (!t.isCallExpression(returnNode)) return;

  var callee = returnNode.callee;
  var args = returnNode.arguments;

  if ((0, _isLodashCall2.default)(callee)) {
    var partialArgs = _fp2.default.flow(_fp2.default.reverse, _fp2.default.zip(_fp2.default, _fp2.default.reverse(params)), _fp2.default.dropWhile(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2);

      var arg = _ref2[0];
      var param = _ref2[1];
      return arg && param && arg.name === param.name;
    }), _fp2.default.map(_fp2.default.first), _fp2.default.reverse)(args);

    if (_fp2.default.isEmpty(partialArgs)) {
      path.replaceWith(callee);
    } else if (partialArgs.length !== args.length) {
      path.replaceWith((0, _buildCall2.default)(callee, partialArgs));
    }
  }
};